﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="default.aspx.cs" Inherits="ReportPagamenti.Default" %>

<!DOCTYPE html>

<!--
          Progetto: Progetto "Pagamenti MSMQ"
 
            Autore: Roberto Fuligni
   Ultima modifica: 24/01/2016
   
       Descrizione: Visualizza i dettagli dei pagamenti più recenti inviati al server dei pagamenti.
                    La pagina riceve periodicamente i dati da visualizzare attraverso un web socket.
                    Il web socket attivo sul server utilizza la porta 1800/tcp.
-->

<html lang="it">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="description" content="">
    <meta name="author" content="">

    <title>Controllo pagamenti</title>

    <link href="Content/bootstrap.min.css" rel="stylesheet">

    <script type="text/javascript">
        var ws;
        var connOff = null;
        var connOn = null;

        function init() {

            if ("WebSocket" in window) {
                document.getElementById("ConnessioneNonSupportata").style.display = "none";
                connOff = document.getElementById("ConnessioneOff");
                connOn = document.getElementById("ConnessioneOn");
                connOff.style.display = "block";
                connOn.style.display = "none";

                ws = new WebSocket("<%= String.Format("ws://{0}", Request.Url.Host) %>:1800/");
                


                ws.onopen = function () {
                    connOff.style.display = "none";
                    connOn.style.display = "block";
                };

                ws.onmessage = function (evt) {

                    // Decodifica il messaggio inviato dal server in formato JSON.

                    var dati = JSON.parse(evt.data);
                    document.getElementById("UltimoAgg").innerHTML = "Ultimo aggiornamento: <strong>" + dati.DataInvio + "</strong>";

                    var righe = "";
                    for (var i = 0; i < dati.Info.length; i++)
                        righe += rigaHtml(dati.Info[i]);


                    document.getElementById("CorpoTabellaInfo").innerHTML = righe;

                };

                ws.onclose = function () {
                    connOff.style.display = "block";
                    connOn.style.display = "none";
                };
            }
        }

        function rigaHtml(r) {

            // Genera il codice HTML necessario alla rappresentazione di una riga di dati

            var nomeImg = "";

            switch (r.TipoCarta) {
                case 1: nomeImg = "visa.gif"; break;
                case 2: nomeImg = "mastercard.gif"; break;
                case 3: nomeImg = "amex.gif"; break;
            }

            var ris = "<tr><td>" + r.Id + "</td><td>" + r.Data + "</td><td>" + r.NomeVenditore + "  (Id: " + r.IdVenditore + ")</td>" +
                "<td>" + r.NomeAcquirente + "</td><td><img src='img/" + nomeImg + "' /></td><td>" + r.NumeroCarta + 
                "</td><td>" + r.ImportoValuta + "</td></tr>";

            return ris;
        }

    </script>


</head>

<body onload="init();">
    <div class="container">

        <div class="page-header">
            <p class="lead">Corso di &ldquo;Tecnologie e progettazione di sistemi informatici e di telecomunicazione&rdquo; &ndash; prof. Roberto Fuligni</p>
            <p>I dati presenti in questa pagina sono inseriti dagli studenti del corso per scopi didattici e non corrispondono in alcun modo a transazioni bancarie reali.</p>
            <div class="row">
                <div class="col-md-8"><h1>Report dei pagamenti</h1></div>
                <div class="col-md-4 pull-right">
                    <div class="alert alert-warning" style="display: normal;" id="ConnessioneNonSupportata">Questo browser non supporta i websocket.</div>
                    <div class="alert alert-danger" style="display: none;" id="ConnessioneOff">Connessione disattivata.</div>
                    <div class="alert alert-success" style="display: none;" id="ConnessioneOn"><span id="UltimoAgg">Connessione in corso...</span></div>
                </div>
            </div>
            
        </div>

        <table class="table table-striped">
            <thead>
                <tr>
                    <th colspan="2">Transazione</th>
                    <th>Venditore</th>
                    <th>Acquirente</th>
                    <th>&nbsp;</th>
                    <th>Carta di credito</th>
                    <th>Importo</th>
                </tr>
            </thead>
            <tbody id="CorpoTabellaInfo">
            </tbody>
        </table>
    </div>
</body>
</html>
