﻿using System.ComponentModel;
using System.Configuration.Install;
using System.Messaging;
using System.ServiceProcess;

/*
 *         Progetto: Progetto "Pagamenti MSMQ"
 * 
 *           Autore: Roberto Fuligni
 *  Ultima modifica: 24/01/2016
 *  
 *      Descrizione: Metodi per la gestione delle varie fasi del processo di installazione del servizio.
 *                   
 */

namespace PagamentiMSMQ
{
    [RunInstaller(true)]
    public partial class ProjectInstaller : System.Configuration.Install.Installer
    {
        public ProjectInstaller()
        {
            InitializeComponent();
        }

        private void messageQueueInstaller1_AfterInstall(object sender, InstallEventArgs e)
        {
            var inst = (MessageQueueInstaller)sender;

            AccessControlList acl = new AccessControlList();

            acl.Add(new MessageQueueAccessControlEntry(
                new Trustee("LOCALSERVICE"),
                MessageQueueAccessRights.FullControl));

            inst.Permissions = acl;

        }

        private void serviceInstaller1_BeforeUninstall(object sender, InstallEventArgs e)
        {
            using (ServiceController sc = new ServiceController(serviceInstaller1.ServiceName))
            {
                if (sc.Status == ServiceControllerStatus.Running)
                    sc.Stop();
            }
        }

        private void messageQueueInstaller1_Committed(object sender, InstallEventArgs e)
        {
            using (ServiceController sc = new ServiceController(serviceInstaller1.ServiceName))
            {
                sc.Start();
            }
        }
    }
}
